



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS枚举的运用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS枚举的运用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 20:01:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1.什么是枚举？</p>
<blockquote><h2>1.什么是枚举？</h2></blockquote>
<p>枚举其实就是一个整型常数的集合，最简单的例子就是表示星期的SUN, MON, TUE, WED, THU, FRI,SAT, 就是一个枚举。</p>
<blockquote><h2>2.iOS中枚举的使用</h2></blockquote>
<p>在ObjC中可以使用C语言的方式进行枚举，其实ObjC的枚举就是在C语言上演化而来，先了解C语言定义一个枚举的方式有助于我们对枚举的理解。</p>
<blockquote><h3>1.C语言中的枚举（ObjC兼容）</h3></blockquote>
<p>下面我们定义一个枚举类型Animal，形式为 enum 枚举名 {枚举值表} ; &nbsp; 我们在名为Animal的枚举中申明了多个成员名，我们可以看作是整形常量的别名。我们把cat赋值为1，系统会默认为后续枚举成员的值在前一个成员上加1，如dog为2，pig为3以此类推。当然枚举成员的值我们也可以自定义，例如我们可以为cat赋值为50，dog赋值为100，所有的赋值关键就是让编程人员容易读懂和理解。</p>
<pre class="prettyprint linenums"><code>//枚举类型的定义<br />
enum Animal<br />
{<br />
	cat=1, dog, pig, bee, monkey, elephant , butterfly<br />
};<br />
enum Animal animal = cat;//声明Animal枚举型的枚举变量<br />
</code></pre>
<p>我们也可以同时声明枚举类型和枚举型变量，下面第一种定义方式没有定义枚举的类型，但是声明了枚举变量workday。 &nbsp;第二中分别定义了枚举类型enum week和变量days。</p>
<pre class="prettyprint linenums"><code>//类型定义与变量声明同时进行<br />
enum //跟第一个定义不同的是，此处的类型标号省略，这是允许的。<br />
{<br />
    saturday,<br />
    sunday = 0,<br />
    monday,<br />
    tuesday,<br />
    wednesday,<br />
    thursday,<br />
    friday<br />
} workday; //变量workday<br />
enum week { Mon=1, Tue, Wed, Thu, Fri ,Sat, Sun} days; //变量days的类型为枚举型enum week<br />
</code></pre>
<p>用typedef关键字将枚举类型定义成别名，并利用该别名进行变量声明，下面例子中我们将enum Car定义成别名Car。</p>
<pre class="prettyprint linenums"><code>typedef enum Car<br />
{<br />
    //以下是枚举成员<br />
    BMW = 0,<br />
    Benz,<br />
    Ferrari,<br />
    Royce<br />
}Car;//枚举名称<br />
Car  car;//声明Car类型的变量<br />
typedef enum    //可以省略enum Car中的Car<br />
{<br />
    //以下是枚举成员<br />
    BMW = 0,<br />
    Benz,<br />
    Ferrari,<br />
    Royce<br />
}Car;//枚举名称<br />
Car  car;//声明Car类型的变量<br />
</code></pre>
<blockquote><h3>2.iOS中的枚举</h3></blockquote>
<p>在iOS中主要苹果推荐用NS<em>ENUM，NS</em>OPTIONS 两种方式去声明一个枚举。</p>
<p>&bull; NS<em>ENUM声明一般类型,&nbsp;NS</em>OPTIONS声明掩码(bitmasked)类型　　</p>
<p>下面使用NS<em>OPTIONS掩码类型进行声明枚举，形式为 typedef NS</em>OPTIONS(枚举成员类型,枚举类型名称){枚举成员&hellip;};</p>
<p>"&lt;&lt;"是左移运算符，"1 &lt;&lt; 0"表示1左移0位。在二进制中，左移意味着对应的十进制数乘2。</p>
<p>好处：我们在枚举值中看见&lt;&lt;那我们就可以通过|(位运算符:或)进行组合！像下面定义的CatDaily一样</p>
<pre class="prettyprint linenums"><code>//NS_OPTIONS:是用来声明位掩码(bitmasked)<br />
typedef NS_OPTIONS(NSInteger,MyCatEvent) {<br />
    CatNone     = 0,<br />
    CatWalk     = 1 &lt;&lt; 0, // &lt;&lt;表示左移运算符 表示0001<br />
    CatJump     = 1 &lt;&lt; 1,<br />
    CatBark     = 1 &lt;&lt; 2,<br />
    CatEat      = 1 &lt;&lt; 3,<br />
    CatSleep    = 1 &lt;&lt; 4,<br />
    CatDaily     = CatWalk | CatJump<br />
};<br />
</code></pre>
<p>通过&amp;进行判断我们来看看输出结果如下图:</p>
<blockquote><p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/827583/201708/827583-20170816174035443-1967559727.png" /> <img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/827583/201708/827583-20170816174149943-1868054439.png" /></p></blockquote>
<p>我们可以看到我们定义的CatWalk值为1，CatJump为2，所以或运算的value值为3。在打印语句中，我们用value对所有的枚举成员进行与运算。我们可以通过输出的值来判断value。包含哪些枚举成员。结果为0表示不包含，结果为1对应catwalk，以此类推。</p>
<p>用NS<em>ENUM声明一般类型，下面声明了两种枚举类型，类型成员分别赋值十进制数和十六进制数。为什么要用两种不同的方式呢？本质上这两种方式并没有什么区别，但是16进制的数更容易对转换到2进制，当我们需要对枚举成员做与、或运算时更加的方便。 </em></p>
<pre class="prettyprint linenums"><code>//NS_ENUM:是用来声明一般的NSInteger(下面代码使用NSInteger)类型的枚举<br />
typedef NS_ENUM(NSInteger,MyBoyEvent){<br />
    BoyFeedCat  = 0,<br />
    BoyWalkCat  = 1,<br />
};　　<br />
//十六进制枚举<br />
typedef NS_ENUM(NSInteger,DailyEvent){<br />
    DailyNone       = 0x00,<br />
    DailyRead       = 0x01,<br />
    DailyWrite      = 0x02,<br />
    DailySing       = 0x03,<br />
    DailyShopping   = 0x04,<br />
};<br />
</code></pre>
<p>以上如果有任何错误，希望大家指正。</p>
<p>更多的iOS笔记可以来到我的博客：<a href="http://tianxianbob.com" rel="external nofollow noreferrer">tianxianbob.com</a>交流</p>
<p>参考链接：<a href="http://www.cnblogs.com/JCSU/articles/1299051.html" rel="external nofollow noreferrer">http://www.cnblogs.com/JCSU/articles/1299051.html</a></p>
<p>　　　　 <a href="http://www.jianshu.com/p/97e582fe89f3" rel="external nofollow noreferrer">http://www.jianshu.com/p/97e582fe89f3</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z4jyx9.html">十分钟了解分布式计算&colon;Spark</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93vk7g8.html">解决java使用https协议请求出现证书不信任问题（PKIX path building failed）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql7ym09.html">菜单each&plus;hover</a>
		</li>
						<li><a href="https://www.batexi.com/a/390loln9.html">HTML5 Audio and Video 的新属性简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ox1we8.html">【iCore2 模块相关资料】发布模块DEMO 代码包，目前支持 iM&lowbar;TFT30、 iM&lowbar;LAN和 iM&lowbar;RGB 三个模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w51rxq.html">springmvc&plus;ajaxFileUpload上传文件&lpar;前后台彻底分离的情况下&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1v45j9.html">Play Framework 发现并没有热启动的特殊情况</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjlm3y9.html">&period;net学习体会</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj160lq.html">简单的mvc之二：蜿蜒的管线</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gepvp78.html">HP Autonomy KeyView入门使用&amp;amp&semi;Maven打包流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdoy2d9.html">Java EE的未来</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k71l09.html">10-Flink集群的高可用&lpar;搭建篇补充&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyywyg2q.html">关于matplotlib绘制直方图偏移的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rkg4z8.html">第九周助教工作总结&mdash;&mdash;NWNU李泓毅</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wjj1zq.html">IdentityServer4【Topic】之登陆注册</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25x76vq.html">阻止 form 回车 自动提交</a>
		</li>
						<li><a href="https://www.batexi.com/a/96043z39.html">JavaWeb学习 &lpar;十六&rpar;&mdash;&mdash;&mdash;&mdash;JSP中的九个内置对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1wed5q.html">CGAffineTransform  缩放 &sol; 旋转 &sol; 平移</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll3nx6q.html">sitecore系列教程之更改您的个人设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyymp42q.html">1F - A&plus;B for Input-Output Practice &lpar;III&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4zdz739.html">Redis初体验</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mymo48.html">js 、jq强化复习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjwv0z8.html">WdatePicker文本框显示当前日期和时间限制&amp;lt&semi;My97DatePicker两个日期范围不超过30天，第一个小于第二个，都不大于当前日期 &amp;gt&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljvl709.html">Android --&amp;gt&semi; 常见控件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojy1w1q.html">第一章：windows下 python 的安装和使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo3vwvq.html">CSS3-loading动画（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1krjjq.html">Intellij Idea配置说明（从Eclipse转Idea）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyw3wk9.html">Docker初步了解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljvxke9.html">linux查看是否安装Apache，mysql，python等</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojy2lpq.html">Oracle和MySQL分组查询GROUP BY</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
